Index: branches/proxy/src/lib/network/synchronizeable_var/synchronizeable_var.h
===================================================================
--- branches/proxy/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 9346)
+++ branches/proxy/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 9347)
@@ -12,7 +12,8 @@
 
 enum {
-  PERMISSION_SERVER = 1,
-  PERMISSION_OWNER  = 2,
-  PERMISSION_ALL    = 4
+  PERMISSION_MASTER_SERVER = 1,
+  PERMISSION_PROXY_SERVER  = 2,
+  PERMISSION_OWNER         = 4,
+  PERMISSION_ALL           = 8
 };
 
@@ -20,5 +21,5 @@
 
   public:
-    SynchronizeableVar( void * ptrIn, void * ptrOut, std::string name, int length, int permission = PERMISSION_SERVER, int priority = 0 );
+    SynchronizeableVar( void * ptrIn, void * ptrOut, std::string name, int length, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
     virtual ~SynchronizeableVar();
 
@@ -28,6 +29,6 @@
      */
     inline bool beWatched(){ return this->bWatched; }
-    
-    /** 
+
+    /**
      * set flag if synchronizeable wants to be informed on changes
      */
@@ -96,5 +97,5 @@
      */
     inline void resetPriority() { this->priority = this->realPriority; }
-    
+
     /**
      * reads actual size from buffer. this is used when size is not constant
@@ -104,5 +105,5 @@
      */
     virtual inline int getSizeFromBuf( byte * buf, int maxLength ){ return this->getSize(); }
-    
+
     /**
      * set variable id
@@ -110,11 +111,11 @@
      */
     inline void setVarId( int id ){ this->varId = id; }
-    
-    /** 
+
+    /**
      * get variable id
      * @return variable id
      */
     inline int getVarId(){ return varId; }
-    
+
     /**
      * set hasChanged
@@ -122,11 +123,11 @@
      */
     inline void setHasChanged( bool changed ){ this->changed = changed; }
-    
-    /** 
+
+    /**
      * get hasChanged
      * @return variable id
      */
     inline bool getHasChanged(){ return changed; }
-    
+
     /**
      * print out variable value
@@ -137,10 +138,10 @@
   private:
     bool bWatched;      //!< true if synchronizeable wants to be informed on changes
-    
+
     int permission;     //!< who is allowed to change this var
     int priority;       //!< priority assigned to var
     int realPriority;   //!< priority assigned to var, increased every time not sent
     int varId;          //!< id to identify varables
-    
+
     bool changed;       //!< true if last readFromBuf changed anything
 
Index: branches/proxy/src/lib/network/synchronizeable_var/synchronizeable_vector.h
===================================================================
--- branches/proxy/src/lib/network/synchronizeable_var/synchronizeable_vector.h	(revision 9346)
+++ branches/proxy/src/lib/network/synchronizeable_var/synchronizeable_vector.h	(revision 9347)
@@ -14,5 +14,5 @@
 
   public:
-    SynchronizeableVector( Vector * ptrIn, Vector * ptrOut, std::string name, int permission = PERMISSION_SERVER, int priority = 0 );
+    SynchronizeableVector( Vector * ptrIn, Vector * ptrOut, std::string name, int permission = PERMISSION_MASTER_SERVER, int priority = 0 );
     virtual ~SynchronizeableVector();
     
Index: branches/proxy/src/lib/network/tcp_socket.h
===================================================================
--- branches/proxy/src/lib/network/tcp_socket.h	(revision 9346)
+++ branches/proxy/src/lib/network/tcp_socket.h	(revision 9347)
@@ -1,5 +1,5 @@
 /*!
- * @file network_socket.h
-  *  Main interface for the network module. Manages all the modules
+ * @file tcp_socket.h
+  *  tcp socket network interface
 
 */
@@ -47,6 +47,8 @@
 
     virtual void connectToServer( std::string host, int port );
-    
+
     virtual void disconnectServer();
+    virtual void reconnectToServer( std::string host, int port);
+    virtual void reconnectToServerSoft( std::string host, int port);
 
     virtual bool writePacket(byte * data, int length);
Index: branches/proxy/src/lib/network/udp_socket.cc
===================================================================
--- branches/proxy/src/lib/network/udp_socket.cc	(revision 9346)
+++ branches/proxy/src/lib/network/udp_socket.cc	(revision 9347)
@@ -74,4 +74,5 @@
 {
   this->init();
+  this->ip = ip;
   this->serverSocket = serverSocket;
   this->userId = userId;
@@ -105,11 +106,9 @@
   assert( serverSocket == NULL );
 
-  IPaddress ip;
-  
   this->randomByte = generateNewRandomByte();
 
   PRINTF(0)("connect to server %s on port %d\n", host.c_str(), port);
 
-  if ( SDLNet_ResolveHost( &ip, host.c_str(), port ) != 0 )
+  if ( SDLNet_ResolveHost( &this->ip, host.c_str(), port ) != 0 )
   {
     PRINTF(1)("SDLNet_ResolveHost: %s\n", SDLNet_GetError() );
@@ -126,5 +125,5 @@
   }
 
-  int channel = SDLNet_UDP_Bind(socket, 1, &ip);
+  int channel = SDLNet_UDP_Bind(socket, 1, &this->ip);
   if ( channel == -1 )
   {
@@ -147,5 +146,37 @@
   bOk = false;
   socket = NULL;
-}
+
+  this->ip.host = 0;
+  this->ip.port = 0;
+}
+
+
+/**
+ * reconnects to
+ * @param host new server address
+ * @param port new port number
+ *
+ * this terminates the current connection and starts a new connection to the new server
+ */
+void UdpSocket::reconnectToServer( std::string host, int port)
+{
+  // first disconnect the old server
+  this->disconnectServer();
+
+  // now connect to the new
+  this->connectToServer( host, port);
+}
+
+
+/**
+ * reconnects to
+ * @param host new server address
+ * @param port new port number
+ *
+ * this terminates the current connection and starts a new connection to the new server
+ */
+void UdpSocket::reconnectToServerSoft( std::string host, int port)
+{}
+
 
 /**
@@ -179,5 +210,5 @@
 
     byte udpCmd = 0;
-    
+
     if ( networkPacket.length > 0 )
     {
@@ -189,5 +220,5 @@
     else
       return 0;
-      
+
     if ( !checkRandomByte( networkPacket.data[0] ) )
       return 0;
@@ -198,5 +229,5 @@
       networkPacket.data = NULL;
     }
-    
+
     if ( !checkUdpCmd( udpCmd ) )
       return 0;
@@ -207,5 +238,5 @@
   {
     int numrecv = SDLNet_UDP_Recv( socket, packet);
-    
+
     byte udpCmd = 0;
 
@@ -218,8 +249,8 @@
       else
         return 0;
-            
+
       if ( !checkRandomByte( packet->data[0] ) )
         return 0;
-              
+
       if ( !checkUdpCmd( udpCmd ) )
         return 0;
@@ -283,5 +314,5 @@
     return false;
   }
-  
+
   if ( !this->serverSocket && ( udpCmd & UDPCMD_INVALIDRNDBYTE ) )
   {
@@ -292,5 +323,5 @@
     return false;
   }
-  
+
   return true;
 }
@@ -300,7 +331,7 @@
   srand( SDL_GetTicks() );
   byte res = ( rand() & 0xFC );
-  
+
   PRINTF(0)("generated random byte: %x\n", res);
-  
+
   return res;
 }
Index: branches/proxy/src/lib/network/udp_socket.h
===================================================================
--- branches/proxy/src/lib/network/udp_socket.h	(revision 9346)
+++ branches/proxy/src/lib/network/udp_socket.h	(revision 9347)
@@ -31,25 +31,26 @@
 
     virtual void connectToServer( std::string host, int port );
-    
     virtual void disconnectServer();
 
+    virtual void reconnectToServer( std::string host, int port);
+    virtual void reconnectToServerSoft( std::string host, int port);
+
     virtual bool writePacket(byte * data, int length );
+    virtual int readPacket(byte * data, int maxLength);
 
-    virtual int readPacket(byte * data, int maxLength);
-    
+
   private:
     UdpServerSocket * serverSocket;   //!< will get packets here
     int               userId;         //!< user id used by serverSocket
-    IPaddress         ip;             //!< host,port
     UDPsocket         socket;         //!< socket used to send/recieve
     UDPpacket *       packet;
-    
+
     byte              randomByte;     //!< contains random bytes & 0xFC
-    
+
     bool writeRawPacket( byte * data, int length );
     bool checkUdpCmd( byte udpCmd );
     bool checkRandomByte( byte rndByte );
     byte generateNewRandomByte();
-    
+
     void init();
 
Index: branches/proxy/src/lib/shell/shell_command.cc
===================================================================
--- branches/proxy/src/lib/shell/shell_command.cc	(revision 9346)
+++ branches/proxy/src/lib/shell/shell_command.cc	(revision 9347)
@@ -299,5 +299,5 @@
       {
         PRINT(0)("Command '%s' on '%s::%s'\n", sc->getName(), (*bo)->getClassName(), (*bo)->getName());
-        (*sc->executor)((*bo), inputSplits.getSubSet(paramBegin));
+        (*sc->executor)((*bo), inputSplits.subSet(paramBegin));
       }
       return true;
@@ -375,5 +375,5 @@
 //       if(this->completors[parameter] == NULL)
 //       delete this->completors[parameter];
-//       this->completors[parameter] = completorPlugin.clone(); 
+//       this->completors[parameter] = completorPlugin.clone();
     }
     return this;
Index: branches/proxy/src/lib/util/Makefile.am
===================================================================
--- branches/proxy/src/lib/util/Makefile.am	(revision 9346)
+++ branches/proxy/src/lib/util/Makefile.am	(revision 9347)
@@ -6,5 +6,4 @@
 libORXlibutil_a_SOURCES = \
 		substring.cc \
-		tokenizer.cc \
 		color.cc \
 		helper_functions.cc \
@@ -32,5 +31,4 @@
 noinst_HEADERS = \
 		substring.h \
-		tokenizer.h \
 		multi_type.h \
 		color.h \
Index: branches/proxy/src/lib/util/executor/executor_functional.h
===================================================================
--- branches/proxy/src/lib/util/executor/executor_functional.h	(revision 9346)
+++ branches/proxy/src/lib/util/executor/executor_functional.h	(revision 9347)
@@ -179,5 +179,5 @@
   {
     (__EXECUTOR_FUNCTIONAL_FUNCTION_EXEC)(
-      fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) );
+      (sub.size() > 0) ? fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) : (fromMulti<type0>(this->defaultValue[0])));
   };
 
@@ -222,6 +222,6 @@
   {
     (__EXECUTOR_FUNCTIONAL_FUNCTION_EXEC)(
-      fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)),
-      fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)));
+      (sub.size() > 0) ? fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) : (fromMulti<type0>(this->defaultValue[0])),
+      (sub.size() > 1) ? fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)) : (fromMulti<type1>(this->defaultValue[1])));
   };
 
@@ -276,7 +276,7 @@
   {
     (__EXECUTOR_FUNCTIONAL_FUNCTION_EXEC)(
-      fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)),
-      fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)),
-      fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)));
+      (sub.size() > 0) ? fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) : (fromMulti<type0>(this->defaultValue[0])),
+      (sub.size() > 1) ? fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)) : (fromMulti<type1>(this->defaultValue[1])),
+      (sub.size() > 2) ? fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)) : (fromMulti<type2>(this->defaultValue[2])));
   };
 
@@ -333,8 +333,8 @@
   {
     (__EXECUTOR_FUNCTIONAL_FUNCTION_EXEC)(
-      fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)),
-      fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)),
-      fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)),
-      fromString<type3>(sub[3], getDefault<type3>(this->defaultValue, 3)));
+      (sub.size() > 0) ? fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) : (fromMulti<type0>(this->defaultValue[0])),
+      (sub.size() > 1) ? fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)) : (fromMulti<type1>(this->defaultValue[1])),
+      (sub.size() > 2) ? fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)) : (fromMulti<type2>(this->defaultValue[2])),
+      (sub.size() > 3) ? fromString<type3>(sub[3], getDefault<type3>(this->defaultValue, 3)) : (fromMulti<type3>(this->defaultValue[3])));
   };
 
@@ -392,9 +392,9 @@
   {
     (__EXECUTOR_FUNCTIONAL_FUNCTION_EXEC)(
-      fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)),
-      fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)),
-      fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)),
-      fromString<type3>(sub[3], getDefault<type3>(this->defaultValue, 3)),
-      fromString<type4>(sub[4], getDefault<type4>(this->defaultValue, 4)));
+      (sub.size() > 0) ? fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) : (fromMulti<type0>(this->defaultValue[0])),
+      (sub.size() > 1) ? fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)) : (fromMulti<type1>(this->defaultValue[1])),
+      (sub.size() > 2) ? fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)) : (fromMulti<type2>(this->defaultValue[2])),
+      (sub.size() > 3) ? fromString<type3>(sub[3], getDefault<type3>(this->defaultValue, 3)) : (fromMulti<type3>(this->defaultValue[3])),
+      (sub.size() > 4) ? fromString<type4>(sub[4], getDefault<type4>(this->defaultValue, 4)) : (fromMulti<type4>(this->defaultValue[4])));
   };
 
Index: branches/proxy/src/lib/util/executor/functor_list.h
===================================================================
--- branches/proxy/src/lib/util/executor/functor_list.h	(revision 9346)
+++ branches/proxy/src/lib/util/executor/functor_list.h	(revision 9347)
@@ -135,4 +135,5 @@
 
   //! mixed values:
+  FUNCTOR_LIST(2)(l_STRING, l_INT);
   FUNCTOR_LIST(2)(l_STRING, l_FLOAT);
   FUNCTOR_LIST(2)(l_UINT, l_LONG);
Index: branches/proxy/src/lib/util/multi_type.cc
===================================================================
--- branches/proxy/src/lib/util/multi_type.cc	(revision 9346)
+++ branches/proxy/src/lib/util/multi_type.cc	(revision 9347)
@@ -18,9 +18,4 @@
 #include "multi_type.h"
 
-//#include "stdincl.h"
-#include <stddef.h>
-#include <stdlib.h>
-#include <string.h>
-#include <stdio.h>
 #include <sstream>
 
@@ -28,6 +23,4 @@
 #include "debug.h"
 #endif
-
-using namespace std;
 
 /**
Index: branches/proxy/src/lib/util/substring.cc
===================================================================
--- branches/proxy/src/lib/util/substring.cc	(revision 9346)
+++ branches/proxy/src/lib/util/substring.cc	(revision 9347)
@@ -28,8 +28,4 @@
 #include "substring.h"
 
-#include <string.h>
-#include <cassert>
-
-
 /**
  * @brief default constructor
@@ -108,5 +104,5 @@
 
 /** @brief An empty String */
-const std::string SubString::emptyString = "";
+// const std::string SubString::emptyString = "";
 /** @brief Helper that gets you a String consisting of all White Spaces */
 const std::string SubString::WhiteSpaces = " \n\t";
@@ -238,5 +234,8 @@
   }
   else
-    return SubString::emptyString;
+  {
+    static std::string empty;
+    return empty;
+  }
 }
 
@@ -250,5 +249,5 @@
  * SubString::SubString(const SubString& subString, unsigned int subSetBegin)
  */
-SubString SubString::getSubSet(unsigned int subSetBegin) const
+SubString SubString::subSet(unsigned int subSetBegin) const
 {
   return SubString(*this, subSetBegin);
@@ -265,5 +264,5 @@
  * SubString::SubString(const SubString& subString, unsigned int subSetBegin)
  */
-SubString SubString::getSubSet(unsigned int subSetBegin, unsigned int subSetEnd) const
+SubString SubString::subSet(unsigned int subSetBegin, unsigned int subSetEnd) const
 {
   return SubString(*this, subSetBegin, subSetEnd);
@@ -289,6 +288,4 @@
  * Supports delimiters, escape characters,
  * ignores special  characters between safemode_char and between comment_char and linend '\n'.
- *
- *
  */
 SubString::SPLIT_LINE_STATE
Index: branches/proxy/src/lib/util/substring.h
===================================================================
--- branches/proxy/src/lib/util/substring.h	(revision 9346)
+++ branches/proxy/src/lib/util/substring.h	(revision 9347)
@@ -2,8 +2,22 @@
  * @file substring.h
  * @brief a small class to get the parts of a string separated by commas
+ *
+ * This class is also identified as a Tokenizer. It splits up one long
+ * String into multiple small ones by a designated Delimiter.
+ *
+ * Substring is Advanced, and it is possible, to split a string by ','
+ * but also removing leading and trailing spaces around the comma.
+ *
+ * @example
+ * Split the String std::string st = "1345, The new empire   , is , orxonox"
+ * is splitted with:
+ * SubString(st, ',', " \n\t")
+ * into
+ * "1345", "The new empire", "is", "orxonox"
+ * As you can see, the useless spaces around ',' were removed.
  */
 
-#ifndef _SUBSTRING_H
-#define _SUBSTRING_H
+#ifndef __SUBSTRING_H__
+#define __SUBSTRING_H__
 
 #include <vector>
@@ -61,6 +75,6 @@
 
   // retrieve a SubSet from the String
-  SubString getSubSet(unsigned int subSetBegin) const;
-  SubString getSubSet(unsigned int subSetBegin, unsigned int subSetEnd) const;
+  SubString subSet(unsigned int subSetBegin) const;
+  SubString subSet(unsigned int subSetBegin, unsigned int subSetEnd) const;
 
   // retrieve Information from within
@@ -70,7 +84,13 @@
   inline unsigned int size() const { return this->strings.size(); };
   /** @param i the i'th String @returns the i'th string from the subset of Strings */
-  inline const std::string& operator[](unsigned int i) const { return (i < this->strings.size()) ? this->strings[i] : emptyString; };
+  inline const std::string& operator[](unsigned int i) const { return this->strings[i]; };
   /** @param i the i'th String @returns the i'th string from the subset of Strings */
   inline const std::string& getString(unsigned int i) const { return (*this)[i]; };
+  /** @returns the front of the StringList. */
+  inline const std::string& front() const { return this->strings.front(); };
+  /** @returns the back of the StringList. */
+  inline const std::string& back() const { return this->strings.back(); };
+  /** @brief removes the back of the strings list. */
+  inline void pop_back() { this->strings.pop_back(); };
 
   // the almighty algorithm.
@@ -93,7 +113,5 @@
 private:
   std::vector<std::string>  strings;                      //!< strings produced from a single string splitted in multiple strings
-
-  static const std::string emptyString;
 };
 
-#endif /* _SUBSTRING_H */
+#endif /* __SUBSTRING_H__ */
Index: branches/proxy/src/orxonox.cc
===================================================================
--- branches/proxy/src/orxonox.cc	(revision 9346)
+++ branches/proxy/src/orxonox.cc	(revision 9347)
@@ -453,6 +453,6 @@
   if ( Preferences::getInstance()->getString("misc", "bt-to-file", "1") == "1" )
   {
-    SignalHandler::getInstance()->doCatch( argv[0] );
-
+    SignalHandler::getInstance()->doCatch( argv[0], "orxonox.backtrace" );
+    SignalHandler::getInstance()->registerCallback( EventHandler::releaseMouse, NULL );
   }
 
Index: branches/proxy/src/story_entities/multi_player_world_data.cc
===================================================================
--- branches/proxy/src/story_entities/multi_player_world_data.cc	(revision 9346)
+++ branches/proxy/src/story_entities/multi_player_world_data.cc	(revision 9347)
@@ -47,4 +47,5 @@
 #include "player_stats.h"
 
+#include "proxy/proxy_settings.h"
 
 #include "glmenu_imagescreen.h"
@@ -110,6 +111,6 @@
 {
   const TiXmlElement* element = NULL;
-  
-  if( NetworkManager::getInstance()->isGameServer() )
+
+  if( NetworkManager::getInstance()->isMasterServer() )
   {
     /* load the spawning points */
@@ -147,5 +148,5 @@
     element = element->FirstChildElement();
 
-    if( NetworkManager::getInstance()->isGameServer() )
+    if( NetworkManager::getInstance()->isMasterServer() )
     {
       while( element != NULL)
@@ -205,5 +206,5 @@
 
 
-    if( NetworkManager::getInstance()->isGameServer())
+    if( NetworkManager::getInstance()->isMasterServer())
     {
       this->localPlayer = new Player();
@@ -280,6 +281,8 @@
   GameWorldData::loadScene(root);
 
+  LoadParamXML(root, "ProxySettings", ProxySettings::getInstance(), ProxySettings, loadProxySettings);
+
   // create server playable
-  if ( NetworkManager::getInstance()->isGameServer() )
+  if ( NetworkManager::getInstance()->isMasterServer() )
   {
     NetworkGameManager::getInstance()->signalNewPlayer( 0 );
@@ -296,4 +299,7 @@
 ErrorMessage MultiPlayerWorldData::unloadScene()
 {
+  // delete the proxy settings
+  delete ProxySettings::getInstance();
+
   /* call underlying function */
   return GameWorldData::unloadScene();
Index: branches/proxy/src/subprojects/network/network_unit_test.cc
===================================================================
--- branches/proxy/src/subprojects/network/network_unit_test.cc	(revision 9346)
+++ branches/proxy/src/subprojects/network/network_unit_test.cc	(revision 9347)
@@ -208,5 +208,5 @@
 
   /* esatblish a connection */
-  IPaddress ip;
+  IP ip;
   int error = SDLNet_ResolveHost(&ip, "127.0.0.1", port);
   //SDLNet_ResolveHost(&ip, "localhost", port);
@@ -353,5 +353,5 @@
   printf("Connecting to %s, on port %i\n", name, port);
 
-  IPaddress ip;
+  IP ip;
   int error = SDLNet_ResolveHost(&ip, name, port);
   if(error == -1)
Index: branches/proxy/src/subprojects/recapture_mouse/Makefile.am
===================================================================
--- branches/proxy/src/subprojects/recapture_mouse/Makefile.am	(revision 9347)
+++ branches/proxy/src/subprojects/recapture_mouse/Makefile.am	(revision 9347)
@@ -0,0 +1,29 @@
+MAINSRCDIR=../..
+include $(MAINSRCDIR)/defs/include_paths.am
+
+LIB_PREFIX=$(MAINSRCDIR)/lib
+include $(MAINSRCDIR)/lib/BuildLibs.am
+
+
+importer_LDFLAGS = \
+		$(MWINDOWS)
+
+
+bin_PROGRAMS = \
+		recapturemouse
+
+
+DEPENDENCIES = \
+		$(MAINSRCDIR)/world_entities/libORXwe.a \
+		$(libORXlibs_a_LIBRARIES_) \
+		$(MAINSRCDIR)/util/libORXutils.a
+
+LDADD = \
+		$(MAINSRCDIR)/util/libORXutils.a \
+		$(libORXlibs_a_LIBRARIES_) \
+		$(MAINSRCDIR)/world_entities/libORXwe.a \
+		$(libORXlibs_a_LIBRARIES_) \
+		$(MAINSRCDIR)/util/libORXutils.a
+
+recapturemouse_SOURCES= \
+		recapturer.cc
Index: branches/proxy/src/subprojects/recapture_mouse/recapturer.cc
===================================================================
--- branches/proxy/src/subprojects/recapture_mouse/recapturer.cc	(revision 9347)
+++ branches/proxy/src/subprojects/recapture_mouse/recapturer.cc	(revision 9347)
@@ -0,0 +1,27 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+
+   this file extends the framework file, so it renders what i want.
+*/
+
+#include "event_handler.h"
+
+int verbose = 3;
+
+int main(int argc, char** argv)
+{
+  EventHandler::getInstance()->grabEvents(true);
+  EventHandler::getInstance()->grabEvents(false);
+  exit(-1);
+}
Index: branches/proxy/src/util/Makefile.am
===================================================================
--- branches/proxy/src/util/Makefile.am	(revision 9346)
+++ branches/proxy/src/util/Makefile.am	(revision 9347)
@@ -14,4 +14,6 @@
 			singleplayer_shootemup.cc \
 			\
+			\
+			\
 			mission_goal.cc\
 			kill_target.cc\
@@ -24,5 +26,7 @@
 			animation/animation_player.cc \
 			\
-			track/pilot_node.cc
+			track/pilot_node.cc \
+			\
+			network_stats_widget.cc
 
 #			track/track_manager.cc \
@@ -50,5 +54,8 @@
 			animation/t_animation.h \
 			\
-			track/pilot_node.h
+			track/pilot_node.h \
+			\
+			network_stats_widget.h
+
 
 #			track/track_manager.h \
Index: branches/proxy/src/util/game_rules.cc
===================================================================
--- branches/proxy/src/util/game_rules.cc	(revision 9346)
+++ branches/proxy/src/util/game_rules.cc	(revision 9347)
@@ -88,5 +88,5 @@
 void GameRules::registerKill(const Kill& kill)
 {
-  if ( !SharedNetworkData::getInstance()->isGameServer() )
+  if ( !SharedNetworkData::getInstance()->isMasterServer() )
     return;
 
Index: branches/proxy/src/util/multiplayer_team_deathmatch.cc
===================================================================
--- branches/proxy/src/util/multiplayer_team_deathmatch.cc	(revision 9346)
+++ branches/proxy/src/util/multiplayer_team_deathmatch.cc	(revision 9347)
@@ -204,5 +204,5 @@
   assignPlayable();
 
-  if ( !SharedNetworkData::getInstance()->isGameServer() )
+  if ( !SharedNetworkData::getInstance()->isMasterServer() )
     return;
 
@@ -214,5 +214,5 @@
     this->killList.erase( this->killList.begin() );
   }
-  
+
 
 
@@ -268,5 +268,5 @@
 void MultiplayerTeamDeathmatch::checkGameRules()
 {
-  if ( !SharedNetworkData::getInstance()->isGameServer() )
+  if ( !SharedNetworkData::getInstance()->isMasterServer() )
     return;
 
@@ -320,5 +320,5 @@
       return "maps/male_fiend.pcx";
   }
-  
+
   return "";
 }
@@ -330,5 +330,5 @@
     return 10.0f;
   }
-  
+
   return 1.0f;
 }
@@ -680,5 +680,5 @@
   char st[10];
   int i = 0;
-  
+
   i = 2;
   for ( TeamScoreList::const_iterator it = scoreList[0].begin(); it != scoreList[0].end(); it++ )
@@ -719,13 +719,13 @@
     return;
   }
-  
+
   int killerUserId = killer->getOwner();
   int victimUserId = victim->getOwner();
-  
+
   PRINTF(0)("%d %d %x %x %s %s\n", killerUserId, victimUserId, killer, victim, killer->getClassName(), victim->getClassName());
 
   PlayerStats & victimStats = *PlayerStats::getStats( victimUserId );
   PlayerStats & killerStats = *PlayerStats::getStats( killerUserId );
-  
+
   if ( killerStats.getPlayable() != killer || victimStats.getPlayable() != victim )
   {
Index: branches/proxy/src/util/network_stats_widget.cc
===================================================================
--- branches/proxy/src/util/network_stats_widget.cc	(revision 9347)
+++ branches/proxy/src/util/network_stats_widget.cc	(revision 9347)
@@ -0,0 +1,90 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "network_stats_widget.h"
+
+namespace OrxGui
+{
+  /**
+   * @brief standard constructor
+   */
+  NetworkStatsWidget::NetworkStatsWidget ()
+  {
+    //   this->setClassID(CL_PROTO_ID, "NetworkStatsWidget");
+
+    this->_bar.setSize2D(100, 30);
+    this->pack(&this->_valueText);
+    this->_bar.setParent2D(&this->_valueText);
+
+    this->_valueText.setChangedTextColor(Color::white);
+
+    //this->setBackgroundTexture("maps/gui_element_background_2.png");
+    this->setBackgroundColor(Color(.5,.5,.5,1));
+
+    //this->_name.setBackgroundTexture(Texture());
+    //this->_valueText.setBackgroundTexture("maps/gui_element_background_2.png");
+    this->_bar.setBackgroundTexture(Texture());
+    this->_bar.setBackgroundColor(Color(0,0,0,0));
+    this->_bar.setForegroundTexture("maps/gui_element_background_faded.png");
+    this->_bar.setForegroundColor(Color(.5, .5, .5, 1));
+    this->_bar.setChangedValueColor(Color::black);
+  }
+
+
+  /**
+   * @brief standard deconstructor
+   */
+  NetworkStatsWidget::~NetworkStatsWidget ()
+  {
+  }
+
+
+  void NetworkStatsWidget::setMaximum(float max)
+  {
+    this->_bar.setMaximum(max);
+  }
+
+  void NetworkStatsWidget::setValue(float value)
+  {
+    MultiType val(value);
+    val.setType(MT_INT);
+
+
+    this->_bar.setValue(value);
+    this->_bar.setForegroundColor(Color::slerpHSVColor(Color::red, Color::green, value/this->_bar.maximum()));
+    this->_bar.setFrontColor(Color(1,1,1,1), true);
+    this->_valueText.setText(val.getString());
+  }
+
+  void NetworkStatsWidget::resize()
+  {
+    GLGuiBox::resize();
+  }
+
+
+  void NetworkStatsWidget::showing()
+  {
+    this->_valueText.show();
+    this->_bar.show();
+  }
+
+  void NetworkStatsWidget::hiding()
+  {
+    this->_valueText.hide();
+    this->_bar.hide();
+  }
+}
Index: branches/proxy/src/util/network_stats_widget.h
===================================================================
--- branches/proxy/src/util/network_stats_widget.h	(revision 9347)
+++ branches/proxy/src/util/network_stats_widget.h	(revision 9347)
@@ -0,0 +1,59 @@
+/*!
+ * @file network_stats_widget.h
+ * @brief Definition of an EnergyWidget, that displays a bar and a Text
+*/
+
+#ifndef _NETWORK_STATS_WIDGET_H
+#define _NETWORK_STATS_WIDGET_H
+
+#include "glgui_box.h"
+#include "glgui_bar.h"
+#include "glgui_text.h"
+
+#include "network/ip.h"
+
+
+namespace OrxGui
+{
+
+  //! A class to display network Statistics.
+  class NetworkStatsWidget : public GLGuiBox
+  {
+
+  public:
+    NetworkStatsWidget();
+    virtual ~NetworkStatsWidget();
+
+    void setUpstream(unsigned int upstream);
+    void setDownstream(unsigned int upstream);
+    void setIP(const IP& ip);
+
+
+
+    //void rebuildConnectedHosts(std::vector<hosts> hosts);
+
+    void setMaximum(float max);
+    void setValue(float value);
+
+  protected:
+    virtual void resize();
+    virtual void showing();
+    virtual void hiding();
+
+  private:
+    IP                     _ip;
+    GLGuiText              _ipText;
+
+    GLGuiText              _upstreamText;
+    GLGuiText              _downstreamText;
+
+    std::vector<GLGuiText> _connectedHosts;
+
+    GLGuiText              _serverIP;
+
+
+    GLGuiText              _valueText;
+    GLGuiBar               _bar;
+  };
+}
+#endif /* _NETWORK_STATS_WIDGET_H */
